VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWebApp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mHTMLSendString As String       ' The HTML that is sent back to the browser.
Private mUserState      As clsUserState ' The state information for one user.

Public Sub OnStartPage(ByRef rScriptingcontext As ScriptingContext)
    Set gAspAppl = rScriptingcontext.Application
    Set gAspReq = rScriptingcontext.Request
    Set gAspResp = rScriptingcontext.Response
    Set gAspServer = rScriptingcontext.Server
    Set gAspSession = rScriptingcontext.Session
End Sub

Public Sub WebMain()
    On Error GoTo ErrHandler
    
    ' Try to restore this user's state information.
    Set mUserState = New clsUserState
    mUserState.UserID = gAspReq.QueryString("uid")
    Call mUserState.GetState
    
    Select Case gAspReq.QueryString("action")
        Case "SearchSend"
            Call SearchSend
        Case "SearchProc"
            Call SearchProc
        Case "DetailProc"
            Call DetailProc
        Case "AddProc"
            Call AddProc
        Case "ViewSelected"
            Call ViewSelected
        Case Else ' Otherwise send a default page.
            Call SearchSend
    End Select
    
    ' Rewrite any URLs in the HTML string to include the User ID.
    mHTMLSendString = Replace(mHTMLSendString, "{uid}", mUserState.UserID)
    Call gAspResp.Write(mHTMLSendString)
    
    ' Save this user's state information.
    Call mUserState.SaveState
    
    Exit Sub
ErrHandler:
    Call gAspResp.Write(Err.Description)
End Sub

Private Function LoadHTML(ByVal lFileName As String) As String
    Dim lFileNbr  As Integer
    On Error GoTo ErrHandler
    lFileNbr = FreeFile
    Open App.Path & "\" & lFileName For Input Access Read As #lFileNbr
    LoadHTML = Input(LOF(lFileNbr), lFileNbr)
    Close #lFileNbr
    Exit Function
ErrHandler:
    Call Err.Raise(vbObjectError, "clsWebApp", "Can't load html file " & lFileName & ". " & Err.Description)
End Function

Private Sub SearchSend()
    Dim lHTML As String
    lHTML = LoadHTML("Search.htm")
    lHTML = Replace(lHTML, "{Filter}", mUserState.Filter)
    lHTML = Replace(lHTML, "{PublishersTable}", "")
    mHTMLSendString = lHTML
End Sub

Private Sub SearchProc()
    Dim lHTML   As String
    Dim lTable  As String
    Dim lDB     As ADODB.Connection
    Dim lRS     As ADODB.Recordset
        
    ' Get the Filter value from the form.
    mUserState.Filter = gAspReq.Item("txtFilter")
    
    ' Query the database for the matching Publishers and store
    ' the results into the lTable string array.
    Set lDB = New ADODB.Connection
    Call lDB.Open("Driver={Microsoft Access Driver (*.mdb)}; DBQ=" _
        & App.Path & "\Biblio.mdb")
    Set lRS = lDB.Execute("SELECT * FROM Publishers" _
        & " WHERE Name LIKE '%" & mUserState.Filter & "%'" _
        & " ORDER BY Name")
    
    lTable = "<table border=1><TR><TD>Name</TD><TD>Telephone</TD></TR>"
    Do Until lRS.EOF = True
        ' Hyperlink to show the detail for this publisher.
        lTable = lTable _
            & "<TR><TD><a href='PubWebUI.asp?uid={uid}&action=DetailProc&PubID=" _
            & lRS!PubID & "'>" & lRS!Name & "</TD>"
        lTable = lTable & "<TD>" & lRS!Telephone & "</TD></TR>"
        Call lRS.MoveNext
    Loop
    lTable = lTable & "</table>"

    ' Load the HTML file and replace the tokens.
    lHTML = LoadHTML("Search.htm")
    lHTML = Replace(lHTML, "{Filter}", mUserState.Filter)
    lHTML = Replace(lHTML, "{PublishersTable}", lTable)
    mHTMLSendString = lHTML
End Sub

Private Sub DetailProc()
    Dim lHTML As String
    Dim lDB   As ADODB.Connection
    Dim lRS   As ADODB.Recordset

    ' Query the database for the indicated Publisher.
    Set lDB = New ADODB.Connection
    Call lDB.Open("Driver={Microsoft Access Driver (*.mdb)}; DBQ=" _
        & App.Path & "\Biblio.mdb")
    Set lRS = lDB.Execute("SELECT * FROM Publishers" _
        & " WHERE PubID = " & gAspReq.QueryString.Item("PubID"))
    
    ' Load the HTML file.
    lHTML = LoadHTML("Detail.htm")

    ' Replace the tokens in the HTML with the Publisher data.
    lHTML = Replace(lHTML, "{PubID}", CStr(lRS!PubID))
    lHTML = Replace(lHTML, "{Name}", "" & lRS!Name)
    lHTML = Replace(lHTML, "{Company}", "" & lRS![Company Name])
    lHTML = Replace(lHTML, "{Address}", "" & lRS!Address)
    lHTML = Replace(lHTML, "{City}", "" & lRS!City)
    lHTML = Replace(lHTML, "{State}", "" & lRS!State)
    lHTML = Replace(lHTML, "{Zip}", "" & lRS!Zip)
    lHTML = Replace(lHTML, "{Telephone}", "" & lRS!Telephone)
    lHTML = Replace(lHTML, "{Fax}", "" & lRS!Fax)
    mHTMLSendString = lHTML
End Sub

Private Sub AddProc()
    Dim lHTML As String
    Dim lDB   As ADODB.Connection
    Dim lRS   As ADODB.Recordset
    
    ' Query the database for the indicated Publisher.
    Set lDB = New ADODB.Connection
    Call lDB.Open("Driver={Microsoft Access Driver (*.mdb)}; DBQ=" _
        & App.Path & "\Biblio.mdb")
    Set lRS = lDB.Execute("SELECT * FROM Publishers" _
        & " WHERE PubID = " & gAspReq.QueryString.Item("PubID"))
    
    ' Add it to the state object's collection.
    Dim lPubState As clsPubState
    Set lPubState = New clsPubState
    
    lPubState.PubID = lRS!PubID
    lPubState.Name = "" & lRS!Name
    lPubState.Phone = "" & lRS!Telephone
    
    Call mUserState.Publishers.Add(lPubState)
    
    ' Load the confirmation HTML file.
    lHTML = LoadHTML("AddConfirm.htm")

    ' Replace the tokens in the HTML with the Publisher data.
    lHTML = Replace(lHTML, "{Name}", "" & lPubState.Name)

    mHTMLSendString = lHTML
End Sub

Private Sub ViewSelected()
    Dim lHTML     As String
    Dim lTable    As String
    Dim lPubState As clsPubState
    
    lTable = "<table border=1><TR><TD>Name</TD><TD>Telephone</TD></TR>"
    
    For Each lPubState In mUserState.Publishers
        ' Hyperlink to show the detail for this publisher.
        lTable = lTable _
            & "<TR><TD><a href='PubWebUI.asp?uid={uid}&action=DetailProc&PubID=" _
            & lPubState.PubID & "'>" & lPubState.Name & "</TD>"
        lTable = lTable & "<TD>" & lPubState.Phone & "</TD></TR>"
    Next lPubState
    lTable = lTable & "</table>"

    ' Load the HTML file and replace the tokens.
    lHTML = LoadHTML("ViewSelected.htm")
    lHTML = Replace(lHTML, "{PublishersTable}", lTable)
    mHTMLSendString = lHTML
End Sub
